#!/usr/bin/python
# -*- coding: utf-8 -*-

import os, sys
from psview import *

class PsForm(Form1):
	def __init__(self):
		Form1.__init__(self)

	def showPs(self):
		if self.radioButton1.isChecked():
			all = 'a'
		else:
			all = ''

		fields = 'o'
		if self.checkBox1.isChecked():
			fields += 'pid,'
		if self.checkBox2.isChecked():
			fields += 'user,'
		if self.checkBox3.isChecked():
			fields += 'stat,'
		if self.checkBox4.isChecked():
			fields += 'command,'
		fields = fields[:-1]

		filter = self.lineEdit1.text()

		if filter:
			cmd = 'ps %sx%s | grep %s | grep -v grep' % (all, fields, filter)
			head = os.popen('ps %s | head' % fields).readline()
			body = os.popen(cmd).read()
		else:
			cmd = 'ps %sx%s' % (all, fields)
			pspipe = os.popen(cmd)
			head = pspipe.readline()
			body = pspipe.read()
			pspipe.close()
		
		self.tl_header.setText(head)
		self.te_body.setText(body)


app = QApplication(sys.argv)
form = PsForm()
app.setMainWidget(form)
form.show()
app.exec_loop()
